#include <stdio.h>
#include <stdlib.h>
struct elementas
{
   int duom;
   struct elementas *kitas;
};
void sukurtiSarasa (int a, struct elementas **pradzia, struct elementas **pabaiga)
{
    struct elementas *q; // q-sukurtas sarasas
    if(a != 0) // a tas pats kas nr
    {
        if (*pradzia == NULL)
        {
            q = (struct elementas *) malloc(sizeof(struct elementas));
            q->duom = a;
            q->kitas = NULL;
            *pabaiga = q;
            *pradzia = q;
        }
        else
        {
            q = (struct elementas *) malloc(sizeof(struct elementas));
            q->duom = a;
            q->kitas = NULL;
            (*pabaiga)->kitas = q;
            *pabaiga = q;
        }
    }
}

void spausdintiSarasa (struct elementas *elem)
{
    int i = 1;
    printf("Spausdiname sarasa: \n");
    if ( elem == NULL )
    {
        printf("Sarasas yra tuscias");
    }
    while ( elem != NULL )
    {
        printf("%d\n",elem->duom);
        elem = elem->kitas;
        i++;
    }
}
void didziausiasElementas (struct elementas **pradzia, struct elementas **pabaiga)
{
    struct elementas *elem; // elem-naujai sukurtas sarasas
    int i = 1, didz;

    elem = *pradzia;
    didz = elem->duom;
    int nr = 1;
    while (elem->kitas != NULL )
    {
        i++;
        elem = elem->kitas;
        if (elem->duom > didz)
        {
            nr = i;
            didz = elem->duom;
        }
    }
    printf("Didziausias saraso elementas: %d\n", didz);
    elem = *pradzia;
    struct elementas *q;
    q = (struct elementas *) malloc(sizeof(struct elementas));
    q->duom = didz;
    q->kitas = *pradzia;
    *pradzia = q;
    pradzia = &((*pradzia)->kitas);
    while(*pradzia != NULL)
    {
        if ((*pradzia)->duom == didz)
        {
            struct elementas *elem2 = *pradzia;
            *pradzia = (*pradzia)->kitas;
            free(elem2); // istustina elem2 saraso atminti
        }
        else
        {
            pradzia = &((*pradzia)->kitas);
        }
    }
}
void naikintiSarasa (struct elementas **pr, struct elementas **pab)

  {
    struct elementas *einam;
    printf("Naikiname sarasa nuo pabaigos:\n");
    while (*pr != NULL)
    {
        einam = *pr;
        if ( *pab != *pr )
        {
            while ( einam->kitas != *pab )
            einam = einam->kitas;
            *pab = einam;
            printf(" %d ", einam->kitas->duom );
            free ( einam->kitas );
        }
        else
        {
            printf( " %d \n ", einam->duom );
            free (einam);
            *pr = NULL;
            *pab = NULL;
        }
    }
    printf("Sarasas buvo sunaikintas \n");
}
 int main()
  {
        int nr = 1, pasirinkimas; // nr - skaicius kuri ivedame, strukturoje prilygsta duom
        struct elementas *pradzia = NULL, *pabaiga = NULL;
        while (1)
        {
            printf("Spauskite 1, kad sukurti sarasa\n");
            printf("Spauskite 2, kad sunaikinti sarasa\n");
            printf("Spauskite 3, kad rasti ir sunaikinti didziausia saraso elementa\n");
            printf("Spauskite 4, kad spausdinti sarasa \n");
            printf("Spauskite 5, kad iseiti is programos \n");
            scanf("%d", &pasirinkimas);
            switch(pasirinkimas)
            {
                case 1:
                    printf("Iveskite saraso elementus, noredami baigti iveskite 0");
                    while(1)
                    {
                        scanf("%d", &nr);
                        if (nr!=0)
                            sukurtiSarasa(nr, &pradzia, &pabaiga);
                        else
                            break;
                    }
                    break;

                case 2:
                    naikintiSarasa(&pradzia, &pabaiga);
                    break;
                case 3:
                    didziausiasElementas(&pradzia, &pabaiga);
                    break;
                case 4:
                    spausdintiSarasa(pradzia);
                    break;
                case 5:
                    exit(1);
                default:
                    printf("Ivedete netinkama skaiciu");
                    break;
                    }

            }
            return 0;
        }
